% A function for calculating the negative concentrated log-likelihood
% of the spatial error dependence (SED) model where errors follow
% a pure SAR process.

function delta = FEnSarar(YN,XN,W,ev,n,lb,ub)
         warning('off', 'all');  
         opd  = optimset('Display','off','Diagnostics','off','MaxFunEvals',200,...
                    'Algorithm','active-set','MaxIter',500,'TolFun',1E-05);  
         delta = fmincon(@FEnSarar,[0,0],[],[],[],[],lb,ub,[],opd);
function f = FEnSarar(delta)
        nt = length(YN)              ;
        In = eye(n)                  ;
        It = eye(nt/n)               ;
         A = kron(It,(In-delta(1)*W));
         B = kron(It,(In-delta(2)*W));
       BXN = B*XN                    ;
       AYN = A*YN                    ;
      BAYN = B*AYN                   ; 
    XNBBXN = (BXN)'*BXN              ;
   XNBBXNI = pinv(XNBBXN)            ;
   XNBBAYN = BXN'*BAYN               ;
      beth = XNBBXNI*XNBBAYN         ;
       eps = BAYN-BXN*beth           ;
       sig = eps'*eps/nt             ;
         f = .5*log(sig)-sum(log(1-delta(1)*ev))/n-sum(log(1-delta(2)*ev))/n;
end
end