% Nested function that computes the adjusted QMLE of SARA model

function root = FEnSararA(Y,X,W,t,par)
warning('off', 'all');
opd = optimset('Display', 'off');

root = fsolve(@acqs, par, opd);

function  f = acqs(par)
          N = length(Y)     ;
          k = length(X(1,:));
         It = eye(t-1)      ;         
         IN = eye(N)        ;

         WP = kron(It,W)    ;
         B1 = IN-par(1)*WP  ;  IB1 = pinv(B1)    ;  
         B2 = IN-par(2)*WP  ;  IB2 = pinv(B2)    ;
         G1 = WP*IB1        ;  G1b = trace(G1)/N ;
         G2 = WP*IB2        ;  G2b = trace(G2)/N ;
 
         XB = B2*X                               ;         
         YB = B2*B1*Y                            ; 
         IR = pinv(XB'*XB)                       ;
         MN = IN-XB*IR*XB'                       ;
         P1 = MN*(B2*G1*IB2-G1b*IN)              ;
         P2 = MN*(G2-G2b*IN)*MN                  ;         
         VE = MN*YB                              ;
       sig2 = VE'*VE/(N-k)                       ;
 
       f(1) = YB'*P1*YB-sig2*trace(P1) ;
       f(2) = YB'*P2*YB-sig2*trace(P2) ;
end

end