function [x fval] = FnAQSE_STLE(DY,DY_1,DX,W1,W2,W3,C0,par)
% Nested function that computes the objective function
warning('off', 'all');
opd = optimset('Display', 'off');

[x fval] = fsolve(@ScSDPD_F, par, opd);

    function f = ScSDPD_F(par)
    n  = length(W1);
    t  = 1+length(DY)/n;
    In = eye(n);
    It = eye(t-1);
    rho = par(1);
    la1 = par(2);
    la2 = par(3);
    la3 = par(4);
    WT1 = kron(It,W1);
    WT2 = kron(It,W2);
    B1  = In-la1*W1;
    B2  = rho*In+la2*W2;
    B3  = In-la3*W3;
    IC0 = pinv(C0);
    IC  = kron(IC0,In);
    IB3 = pinv(B3);
    IOm = kron(IC0,B3'*B3);
    DDY = kron(It,B1)*DY-kron(It,B2)*DY_1;
    du  = DDY-DX*pinv(DX'*IOm*DX)*DX'*IOm*DDY;
    sigh = sqrt(du'*IOm*du/(n*(t-1)));

    D    = Fn_DMat(W1,W2,t,par);
    D_1  = Fn_DMat_1(W1,W2,t,par);
    
    f(1) = du'*IOm*DY_1/sigh^2 + trace(IC*D_1);
    f(2) = du'*IOm*WT1*DY/sigh^2 + trace(IC*D*WT1);
    f(3) = du'*IOm*WT2*DY_1/sigh^2 + trace(IC*D_1*WT2);
    f(4) = du'*kron(IC0, W3'*B3)*du/sigh^2 - (t-1)*trace(W3*IB3);
    end

end