% A function for calculating the Adjusted Concentrated Quasi Score at H0,
% SAC Model

function f = FnAcqs(Y,X,W,Z,par)
         n = length(Y)      ;
         k = length(X(1,:)) ;
         In = eye(n)        ;
         B1 = In-par(1)*W   ;  IB1 = pinv(B1)    ;  
         B2 = In-par(2)*W   ;  IB2 = pinv(B2)    ;
         G1 = W*IB1         ;  G1b = trace(G1)/n ;
         G2 = W*IB2         ;  G2b = trace(G2)/n ;

         XB = B2*X                               ;         
         YB = B2*B1*Y                            ; 
         IR = pinv(XB'*XB)                       ;
         Mn = In-XB*IR*XB'                       ;
        imi = (1./sum(Mn.^2))'                   ;
         P1 = Mn*(B2*G1*IB2-G1b*In)              ;
         P2 = Mn*(G2-G2b*In)*Mn                  ;         
         VE = Mn*YB                              ;
       sig2 = VE'*VE/(n-k)                       ;
        xis = 0.5*(imi.*VE.^2 - sig2*ones(n,1))  ;        

        f(1) = YB'*P1*YB-sig2*trace(P1) ;
        f(2) = YB'*P2*YB-sig2*trace(P2) ;
        f(3) = Z'*xis                   ;
end