function [x fval] = FnCQMLE_STLE(DY,DY_1,DX,W1,W2,W3,C0,lb,ub,par)
% Nested function that computes the objective function
warning('off', 'all');
opd = optimset('Display', 'off');
lb0 = [lb lb];
ub0 = [ub ub];

[x fval] = fmincon(@FnSDPD_F,par,[],[],[],[],lb0,ub0,[],opd);

    function f = FnSDPD_F(par)
    n  = length(W1);
    t  = 1+length(DY)/n;
    In = eye(n);
    It = eye(t-1);
    IC0 = pinv(C0);

    WT2 = kron(It,W2);    
    B1 = In-par(1)*W1;
    B3 = In-par(2)*W3;

    IOm = kron(IC0, B3'*B3);
    XXC = [DX, DY_1, WT2*DY_1];
    BDY = kron(It, B1)*DY;
    du = BDY-XXC*pinv(XXC'*IOm*XXC)*XXC'*IOm*BDY;

    f = .5*log(du'*IOm*du) - log(det(B3))/n - log(det(B1))/n;
    end

end