function [x fval] = FnFAQSSE_STLE(DY,DY_1,DX,W1,W2,W3,C0,par)
% Nested function that computes the objective function
warning('off', 'all');
opd = optimset('Display', 'off');

[x fval] = fsolve(@ScSDPD_F, par, opd);

    function f = ScSDPD_F(par)
    n     = length(W1);
    t     = 1+length(DY)/n;
    In    = eye(n);
    It    = eye(t-1);
    betaM = par(1);
    sig2  = par(2);
    rho   = par(3);
    la1   = par(4);
    la2   = par(5);
    la3   = par(6);
    
    WT1  = kron(It,W1)                      ;
    WT2  = kron(It,W2)                      ;
    B1   = In - la1*W1                      ;
    B2   = rho*In + la2*W2                  ;
    B3   = In - la3*W3                      ;
    IC0  = pinv(C0)                         ;
    IC   = kron(IC0,In)                     ;
    IB3  = pinv(B3)                         ;
    IOm  = kron(IC0,B3'*B3)                 ;
    DDY  = kron(It,B1)*DY - kron(It,B2)*DY_1;
    du   = DDY - DX*betaM                   ;
    
    dpar = [par(3), par(4), par(5)];
    D    = Fn_DMat(W1,W2,t,dpar)   ;
    D_1  = Fn_DMat_1(W1,W2,t,dpar) ;
    
    f(1) = DX'*IOm*du/sig2                                   ;
    f(2) = du'*IOm*du/(2*(sig2^2))      - (n*(t-1))/(2*sig2) ;
    f(3) = du'*IOm*DY_1/sig2            + trace(IC*D_1)      ;
    f(4) = du'*IOm*WT1*DY/sig2          + trace(IC*D*WT1)    ;
    f(5) = du'*IOm*WT2*DY_1/sig2        + trace(IC*D_1*WT2)  ;
    f(6) = du'*kron(IC0,W3'*B3)*du/sig2 - (t-1)*trace(W3*IB3);
    end

end