function [x fval] = FnMAQSE_STLE(DY,DY_1,DX,W1,W2,W3,C0,df,par)
% Nested function that computes the objective function
warning('off', 'all');
opd = optimset('Display', 'off');

[x fval] = fsolve(@ScSDPD_F, par, opd);

    function f = ScSDPD_F(par)
    n  = length(W1);
    t  = 1+length(DY)/n;
    In = eye(n);
    It = eye(t-1);
    rho = par(1);
    la1 = par(2);
    la2 = par(3);
    la3 = par(4);
    WT1 = kron(It,W1);
    WT2 = kron(It,W2);
    B1  = In-la1*W1;
    B2  = rho*In+la2*W2;
    B3  = In-la3*W3;
    IC0 = pinv(C0);
    IB3 = pinv(B3);
    B3N = kron(It,B3);
    iB3N = pinv(B3N);
    G3  = W3*IB3          ;
    IOm = kron(IC0,B3'*B3);
    DDY = kron(It,B1)*DY-kron(It,B2)*DY_1;
    du  = DDY-DX*pinv(DX'*IOm*DX)*DX'*IOm*DDY;
    
    CC       = kron(C0,In)                     ;
    Ci05     = CC^(-0.5)                       ; 
    DXIOXD   = pinv(DX'*IOm*DX)                ;
    DXBN     =  Ci05*B3N*DX                    ;
    M_N      = eye(n*(t-1)) - DXBN*DXIOXD*DXBN';
    M_o      = Ci05*M_N*Ci05                   ;
    MoB3N    = M_o*B3N                         ;
    sig2hM_s = (1/df)*du'*B3N'*M_o*B3N*du      ;

    D_N    = Fn_DMat(W1,W2,t,par)  ;
    D_N_1  = Fn_DMat_1(W1,W2,t,par);

    mu_s_Rho = - trace(MoB3N*D_N_1*iB3N)    ;
    mu_s_l1  = - trace(MoB3N*WT1*D_N*iB3N)  ;
    mu_s_l2  = - trace(MoB3N*WT2*D_N_1*iB3N);
    mu_s_l3  =   trace(M_N*kron(It,G3))     ; 
      
    f(1) = du'*IOm*DY_1                 - mu_s_Rho*sig2hM_s;
    f(2) = du'*IOm*WT1*DY               - mu_s_l1*sig2hM_s;
    f(3) = du'*IOm*WT2*DY_1             - mu_s_l2*sig2hM_s;
    f(4) = du'*B3N'*kron(IC0,G3)*B3N*du - mu_s_l3*sig2hM_s;
    end

end