% A function for calculating the negative concentrated log-likelihood
% of the spatial error dependence (SED) model where errors follow
% a pure SAR process.

function delta = FnSarar(Y,X,W,ev,lb,ub)
         warning('off', 'all');  
         opd  = optimset('Display','off','Diagnostics','off','MaxFunEvals',200,...
                    'Algorithm','interior-point','MaxIter',500,'TolFun',1E-05);  
         delta = fmincon(@FnSarar,[0,0],[],[],[],[],lb,ub,[],opd);
function f = FnSarar(delta)
         n = length(Y);
        In = eye(n);
         A = In-delta(1)*W;
         B = In-delta(2)*W;
        BX = B*X;
        AY = A*Y;
       BAY = B*AY; 
      XBBX = (BX)'*BX;
     XBBXI = pinv(XBBX);
     XBBAY = BX'*BAY;
      beth = XBBXI*XBBAY;
       eps = BAY-BX*beth;
       sig = eps'*eps/n;
         f = .5*log(sig)-sum(log(1-delta(1)*ev))/n-sum(log(1-delta(2)*ev))/n;
end
end