function [coefx] = Fn_CrossDSL(z0,lb,ub,x_e,y_e,W)

options  = optimset('Display','off','Diagnostics','off','MaxFunEvals',200,...
                    'Algorithm','interior-point','MaxIter',500,'TolFun',1E-05);  

[coefx] = fmincon(@vraisemre,z0,[],[],[],[],lb,ub,[],options);

function F = vraisemre(z)
   n     = length(W)          ;
   B1n   = eye(n) - z(1)*W    ;   
   B2n   = eye(n) - z(2)*W    ;   
   YnL   = B2n*B1n*y_e        ;
   XnL2  = B2n*x_e            ;
   MnL2  = eye(n) - XnL2*pinv(XnL2'*XnL2)*XnL2';
   Sig2v = (1/n)*YnL'*MnL2*YnL                 ;
   F     = -(-(n/2)*(log(2*pi)+1) - (n/2)*log(Sig2v) + log(det(B1n)) + log(det(B2n)));     
end
end
