function f = Fn_DMat_1(W1,W2,t,dpar)
% Compute Matrices D, T >= 2, at rhoh1, lamh1, lamh2
n   = length(W1);
nt  = n*(t-1);
In  = eye(n);
On  = zeros(n,n);
B1  = In-dpar(2)*W1;
B2  = dpar(1)*In + dpar(3)*W2;
IB1 = pinv(B1);
BB  = IB1*B2;
te0 = (BB-2*In)*IB1;
te1 = (In-BB)^2*IB1;

D_1 = zeros(nt,nt);
if t == 2
    D_1 = IB1;
elseif t == 3
    D_1 = [IB1, On; te0, IB1];
else
    for is = 1:(t-2);
        ids0 = n*(is-1)+1;  ids1 = n*is;  
        D_1(ids0:ids1,ids0:ids1) = IB1;
        D_1((ids1+1):(ids1+n),ids0:ids1) = te0;
        for it = (is+2):(t-1);
            idt0 = n*(it-1)+1;  idt1 = n*it;
            D_1(idt0:idt1,ids0:ids1) = BB^(it-is-2)*te1;
        end
    end
    D_1((n*(t-2)+1):n*(t-1), (n*(t-2)+1):n*(t-1)) = IB1;
end

f = D_1;

