function f = Fn_FDMat(W1,W2,t,dpar)

% Compute Matrices D, T >= 2, at rhoh1, lamh1, lamh2
n   = length(W1);
nt  = n*(t-1);
In  = eye(n);
B1  = In-dpar(4)*W1;
B2  = dpar(3)*In + dpar(5)*W2;
IB1 = pinv(B1);
BB  = IB1*B2;
te0 = (BB-2*In)*IB1;
te1 = (In-BB)^2*IB1;

D  = zeros(nt,nt);
if t == 2
    D  = te0;
elseif t == 3
    D  = [te0, IB1; te1, te0];
else
    for is = 1:(t-2);
        ids0 = n*(is-1)+1;  ids1 = n*is;  
        D(ids0:ids1,ids0:ids1) = te0;
        D(ids0:ids1,(ids1+1):(ids1+n)) = IB1;
        D((ids1+1):(ids1+n),ids0:ids1) = te1;
        for it = (is+2):(t-1);
            idt0 = n*(it-1)+1;  idt1 = n*it;
            D(idt0:idt1,ids0:ids1) = BB^(it-is-1)*te1;
        end
    end
    D((n*(t-2)+1):n*(t-1), (n*(t-2)+1):n*(t-1)) = te0;
end

f = D;
